﻿import flash.display.Sprite;
import flash.events.MouseEvent;

/**
 * Тестовый пример
 * Main выступает в качестве базового класса
 * (прописана в первом фрэйме таймлайна):
 * new Main(this);
 * @author k0t0vich
 */
class Main extends Sprite
{
	private var box:Sprite;
	private var spriteList:Array;
	
	public function Main($parent) 
	{
		super($parent);
		
		// тест аттача - ок
		//	super($parent, "Main");
		
		// тест параметров - ок
		x = 200; 
		y = 200;
		
		// тест addChild - ok
		spriteList = [];
		for (var i:Number = 0; i <10 ; i++) {
			// тест кастомных спрайтов - ок
			var sprite:CustomSprite = new CustomSprite(this);
			spriteList.push(sprite);
			sprite.x = 10*i;
			addChild(sprite);
			// тест вложенных
		}
		
		// тест повторного addChild - ok
		var sp2:Sprite = spriteList[2];
		addChild(sp2);
		
		// тест вложенных - ok
		sp2.addChild(new Sprite(sp2, "Arrow"));
		
		// тест addChildAt - ok
		box = new Sprite(this, "BoxSprite");
		addChildAt(box, 3);
		
		//тест swapChildren - ок
		swapChildren(spriteList[6], box);
		
		// тест setChildIndex, numChildren - ок
		setChildIndex(spriteList[1], numChildren - 1);
		
		// тест - IllegalIndex - ок
		try
		{
			setChildIndex(spriteList[1], numChildren);
		}
		catch (e:Error)
		{
			trace("setChildIndex Error: "+e);
		}
		
		// тест  removeChild - ок
		removeChild(sp2);
		
		// тест removeChildAt - ок
		removeChildAt(0);
		
		// тест - IllegalIndex - ок
		try
		{
			removeChildAt(10);
		}
		catch (e:Error)
		{
			trace("removeChildAt Error: "+e);
		}
		
		//тест mouseClick/ add/removeListeners - проблема с показом эвента ролловер
		box.addEventListener(MouseEvent.CLICK, traceEvent, this);
		//box.addEventListener(MouseEvent.ROLL_OVER, traceEvent3, this);
		
		// всплываемое событие
		
	}
	
	private function traceEvent3(e:MouseEvent):Void 
	{
		trace("Main.traceEvent3 > e : " + e);
	}
	
	private function traceEvent(e:MouseEvent):Void 
	{
		trace("Main.traceEvent > e : " + e);

		e.currentTarget.removeEventListener(MouseEvent.CLICK, traceEvent, this);
		// вешаем 2 листенер
		trace("remove");
		//FIXED: прикольная ситуация  - диспетчеризация обрабатывается по списку, и в этот же список добаляется следующий листенер, который и вызывается
		box.addEventListener(MouseEvent.CLICK, traceEvent2, this); 
		}
	
	private function traceEvent2(e:MouseEvent):Void 
	{
		trace("Main.traceEvent2 > e : " + e);

		e.currentTarget.removeEventListener(MouseEvent.CLICK, traceEvent2, this);
		e.currentTarget.removeEventListener(MouseEvent.ROLL_OVER, traceEvent3, this);
	}
	
}