﻿import flash.display.DisplayObject;
import flash.events.Event;
import flash.events.MouseEvent;
import mx.utils.Delegate;
/**
 * Класс интерактивности (диспетчерезация событий мыши) + AS3 методы
 * @author k0t0vich
 */
class flash.display.InteractiveObject extends DisplayObject
{
	
	public function InteractiveObject($parent,linkageName) 
	{
		super($parent, linkageName);
	}
	
	// переопределяем с добавлением обработчиков
	public function addEventListener(event:String,listener:Function, scope:Object):Void 
	{
		super.addEventListener(event, listener, scope);
		
		switch(event)
		{
			case MouseEvent.CLICK:
			{
				setOnRelease();
			}
			break;
			
			case MouseEvent.ROLL_OVER:
			case MouseEvent.MOUSE_OVER:
			{
				setOnRollOver();
			}
			break;
			
			case MouseEvent.ROLL_OUT:
			case MouseEvent.MOUSE_OUT:
			{
				setOnRollOut();
			}
			break;
			
			case MouseEvent.MOUSE_DOWN:
			{
				setOnPress();
			}
			break;
			
			default:
			break;
		}
	}
	
	public function removeEventListener(event:String, listener:Function, scope:Object):Function 
	{
		trace("InteractiveObject.removeEventListener > event : " + event + ", listener : " + listener + ", scope : " + scope);
		// удаляем листенер
		//var func:Function  = super.removeEventListener(event, listener, scope);
		super.removeEventListener(event, listener, scope);
		// проходимся по списку оставшихся листенеров
		switch(event)
		{
			case MouseEvent.CLICK:
			case MouseEvent.ROLL_OVER:
			case MouseEvent.MOUSE_OVER:
			case MouseEvent.ROLL_OUT:
			case MouseEvent.MOUSE_OUT:
			case MouseEvent.MOUSE_DOWN:
			{
				var i:Number;
				var l:Number = _eventListeners.length;
				var obj:Object;
				for (i = 0; i < l; i++)
				{
					obj = _eventListeners[i];
					// если еще остались эвенты == event то выходим сразу
					if (obj.e == event)
					{
						trace("есть еще подписчики");
						//return func;
						return null;
						
					}
				}
				// удаляем эвент если нет подписчиков
				removeMouseEventHandler(event);
			}
			break;
		}	
		//return func;
		return null;
	}
	
	private function removeMouseEventHandler(event:String):Void
	{
		trace("InteractiveObject.removeMouseEventHandler > event : " + event);
		switch(event)
		{
			case MouseEvent.CLICK:
			{
				delete mc.onRelease;
				
			}
			break;
			
			case MouseEvent.ROLL_OVER:
			{
				delete mc.onRollOver;
			}
			break;
			
			case MouseEvent.MOUSE_OVER:
			case MouseEvent.ROLL_OUT:
			case MouseEvent.MOUSE_OUT:
			case MouseEvent.MOUSE_DOWN:
			break;
		}	
	}
	
	private function setOnPress():Void
	{
		
	}
	
	private function setOnRollOut():Void
	{
		
	}
	
	private function setOnRollOver():Void
	{
		if (mc.onRollOver == undefined)
		mc.onRollOver = Delegate.create(this,rollover)
	}
	
	private function release():Void 
	{
		trace("InteractiveObject.release");
		this.dispatchEvent(new MouseEvent(MouseEvent.CLICK, true));
	}
	
	private function setOnRelease():Void
	{
		if (mc.onRelease == undefined)
		mc.onRelease = Delegate.create(this,release);
	}
	
	private function rollover():Void 
	{
		this.dispatchEvent(new MouseEvent(MouseEvent.ROLL_OVER, true));
	}
	
	
}