﻿import mx.utils.Delegate;
import  flash.events.Event;
import  flash.events.EventDispatcher;
import  flash.http.LoaderInfo;
import  flash.http.Request;
/**
 * Эмулятор класса Loader (AS3)
 * @author k0t0vich
 */
class  flash.http.Loader extends EventDispatcher
{
	public var className:String = "Loader";
	
	private var _info:LoaderInfo;
	private var _loader:MovieClipLoader;
	
	public function Loader(request:Request)
	{
		super();
		_loader = new MovieClipLoader();
		_loader.addListener(this);
		_info = new LoaderInfo();
		if (request) load(request);
	}
	
	public function load(request:Request):Void
	{
		info.url = request.url;
		info.clip = request.clip;
		_loader.loadClip(request.url, request.clip);
	}
	
	public function unload():Void
	{
		_loader.unloadClip(info.clip);
	}
	
	private function onLoadInit(clip:MovieClip):Void
	{
		dispatchEvent(new Event(Event.INIT));
	}
	
	private function onLoadComplete(clip:MovieClip):Void
	{
		dispatchEvent(new Event(Event.COMPLETE));
		_info.clip.onInit = Delegate.create(this, onInit);
	}
	
	private function onInit():Void 
	{
		dispatchEvent(new Event(Event.INIT));
	}
	
	private function onLoadError(clip:MovieClip, errorCode:String,
									httpStatus:Number):Void
	{
		info.errorCode = errorCode;
		info.httpStatus = httpStatus;
		dispatchEvent(new Event(Event.ERROR));
	}
	
	private function onLoadProgress(clip:MovieClip, loadedBytes:Number,
									totalBytes:Number):Void
	{
		info.loadedBytes = loadedBytes;
		info.totalBytes = totalBytes;
		dispatchEvent(new Event(Event.PROGRESS));
	}
	
	private function onLoadStart(clip:MovieClip):Void
	{
		dispatchEvent(new Event(Event.START));
	}
	
	public function get content():MovieClip
	{
		return info.clip;
	}
	
	public function set content(clip:MovieClip):Void { return; }
	
	public function get info():LoaderInfo { return _info; }
	
	public function set info(value:LoaderInfo):Void { return; }
}